/**
 * \file dcs/perfeval/workload/enterprise.hpp
 *
 * \brief Forward declarations for enterprise workload models.
 *
 * Copyright (C) 2009-2010  Distributed Computing System (DCS) Group, Computer
 * Science Department - University of Piemonte Orientale, Alessandria (Italy).
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * \author Marco Guazzone (marco.guazzone@gmail.com)
 */

#ifndef DCS_PERFEVAL_WORKLOAD_ENTERPRISE_HPP
#define DCS_PERFEVAL_WORKLOAD_ENTERPRISE_HPP


#include <dcs/perfeval/workload/enterprise/any_generator.hpp>
#include <dcs/perfeval/workload/enterprise/any_model.hpp>
#include <dcs/perfeval/workload/enterprise/any_request_category.hpp>
#include <dcs/perfeval/workload/enterprise/base_generator.hpp>
#include <dcs/perfeval/workload/enterprise/base_model.hpp>
#include <dcs/perfeval/workload/enterprise/generator.hpp>
#include <dcs/perfeval/workload/enterprise/generator_adaptor.hpp>
#include <dcs/perfeval/workload/enterprise/user_interaction_mix.hpp>
#include <dcs/perfeval/workload/enterprise/user_interaction_mix_model.hpp>
#include <dcs/perfeval/workload/enterprise/model_adaptor.hpp>
#include <dcs/perfeval/workload/enterprise/user_request.hpp>
#include <dcs/perfeval/workload/enterprise/user_request_spec.hpp>
#include <dcs/perfeval/workload/enterprise/tpcw.hpp>


#endif // DCS_PERFEVAL_WORKLOAD_ENTERPRISE_HPP
